#ifndef CORE51S_P1_IO_H_
#define CORE51S_P1_IO_H_

#define	intr_base	((0x100 * 1) + 0xF000)
#define	t0_base		((0x100 * 0) + 0xF000)		 
#define	t1_base		((0x100 * 4) + 0xF000)
#define	uart_base	((0x100 * 3) + 0xF000)
#define	i2c_base	((0x100 * 15) + 0xF000)
#define	GPIO_base	((0x100 * 2) + 0xF000)
#define	AI_base		((0x100 * 6) + 0xF000)

// CoreInterrupt_00 memory map: 

__xdata at	intr_base+ 0x00 unsigned char FIQSoftInt;
__xdata at	intr_base+ 0x04 unsigned char FIQSoftIntClear;
__xdata at	intr_base+ 0x08 unsigned char FIQEnable;
__xdata at	intr_base+ 0x0C unsigned char FIQEnableClear;
__xdata at	intr_base+ 0x10 unsigned char FIQRawStatus;
__xdata at	intr_base+ 0x14 unsigned char FIQStatus;	
__xdata at	intr_base+ 0x18 unsigned char IRQSoftInt;
__xdata at	intr_base+ 0x1C unsigned char IRQSoftIntClear;
__xdata at	intr_base+ 0x20 unsigned char IRQEnable;
__xdata at	intr_base+ 0x24 unsigned char IRQEnableClear;
__xdata at	intr_base+ 0x28 unsigned char IRQRawStatus;
__xdata at	intr_base+ 0x2C unsigned char IRQStatus;

// CoreTimer_00 memory map: 

__xdata at	t0_base+ 0x00 unsigned char Timer0Load;
__xdata at	t0_base+ 0x04 unsigned char Timer0Value;	
__xdata at	t0_base+ 0x08 unsigned char Timer0Control;
__xdata at	t0_base+ 0x0C unsigned char Timer0Prescale;
__xdata at	t0_base+ 0x10 unsigned char Timer0IntClr;
__xdata at	t0_base+ 0x14 unsigned char Timer0RIS;
__xdata at	t0_base+ 0x18 unsigned char Timer0MIS;

// CoreTimer_01 memory map: 

__xdata at	t1_base+ 0x00 unsigned char Timer1Load;
__xdata at	t1_base+ 0x04 unsigned char Timer1Value;	
__xdata at	t1_base+ 0x08 unsigned char Timer1Control; 
__xdata at	t1_base+ 0x0C unsigned char Timer1Prescale;
__xdata at	t1_base+ 0x10 unsigned char Timer1IntClr;
__xdata at	t1_base+ 0x14 unsigned char Timer1RIS;
__xdata at	t1_base+ 0x18 unsigned char Timer1MIS;

// CoreUARTapb memory map: 

__xdata at	uart_base+ 0x00 unsigned char TxData;	
__xdata at	uart_base+ 0x04 unsigned char RxData;
__xdata at	uart_base+ 0x08 unsigned char Scon1;
__xdata at	uart_base+ 0x0C unsigned char Scon2;
__xdata at	uart_base+ 0x10 unsigned char SStat;

// CoreI2C memory map: 

__xdata at	i2c_base+ 0x00 unsigned char I2Con;
__xdata at	i2c_base+ 0x04 unsigned char I2Stat;
__xdata at	i2c_base+ 0x08 unsigned char I2Data;
__xdata at	i2c_base+ 0x0C unsigned char I2Addr;

// CoreGPIO memory map: 

__xdata at	GPIO_base+ 0x00 unsigned char dataOut;
__xdata at	GPIO_base+ 0x00 unsigned char dataIn;

// CoreAI memory map: 

__xdata at	AI_base+(0x00 * 2) unsigned char ACMcon;
__xdata at	AI_base+(0x02 * 2) unsigned char ACMaddr;
__xdata at	AI_base+(0x04 * 2) unsigned char ACMdata;
__xdata at	AI_base+(0x06 * 2) unsigned char ADCcon1; 
__xdata at	AI_base+(0x08 * 2) unsigned char ADCcon2; 
__xdata at	AI_base+(0x0A * 2) unsigned char ADCcon3; 
__xdata at	AI_base+(0x0C * 2) unsigned char ADCcon4;
__xdata at	AI_base+(0x0E * 2) unsigned char ADCcon5; 
__xdata at	AI_base+(0x10 * 2) unsigned char ADCstat;
__xdata at	AI_base+(0x12 * 2) unsigned char ADCFifo;
__xdata at	AI_base+(0x14 * 2) unsigned char Fifostat; 
__xdata at	AI_base+(0x16 * 2) unsigned char AI_IE;
__xdata at	AI_base+(0x18 * 2) unsigned char AI_int_stat;

#endif /*CORE51S_P1_IO_H_*/
